unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, StdCtrls, inifiles, ExtCtrls, Buttons, unitx;

type

  TADCData = record
   ADC0m, ADC0, ADC1, ADC2, ADC3: word;
  end;

  TReplyData = record
   pc,pb,pa,
   flags,tflags,
   zofscur,
   MCurrent0, MCurrent0x,
   MCurrent1, MCurrent2, MCurrent3: byte;
   ADC0m, ADC0, ADC1, ADC2, ADC3: word;
  end;

  TReadThread = class(TThread)
  public
   fs: string;
   constructor Create;
   procedure Execute; override;
   procedure ShowStr;
  end;

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Program1: TMenuItem;
    About1: TMenuItem;
    Exit1: TMenuItem;
    sb1: TStatusBar;
    ir1: TMenuItem;
    m: TMemo;
    Open1: TMenuItem;
    Close1: TMenuItem;
    Panel1: TPanel;
    Info1: TMenuItem;
    N2: TMenuItem;
    Restart1: TMenuItem;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    data1: TMenuItem;
    BitBtn4: TBitBtn;
    Timer1: TTimer;
    Enabletimer1: TMenuItem;
    SetCurrentTimerInterval1: TMenuItem;
    N1: TMenuItem;
    Label5: TLabel;
    graph1: TMenuItem;
    Label1: TLabel;
    cur: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    l1: TEdit;
    l2: TEdit;
    l3: TEdit;
    mc: TCheckBox;
    limit: TRadioGroup;
    madc: TCheckBox;
    Setmanualcontrol1: TMenuItem;
    Setmanualcurrentlimit1: TMenuItem;
    relay: TLabel;
    Showlog1: TMenuItem;
    ml: TCheckBox;
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure Restart1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure data1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Enabletimer1Click(Sender: TObject);
    procedure SetCurrentTimerInterval1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure madcClick(Sender: TObject);
    procedure Setmanualcontrol1Click(Sender: TObject);
    procedure Setmanualcurrentlimit1Click(Sender: TObject);
    procedure Showlog1Click(Sender: TObject);
    procedure mlClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
   procedure AddStr(s:string);
   function  OpenPort: boolean;
   procedure SendCmd(cmd: string; chars: byte);
   procedure GetCurrent(var d: TADCData; errbox: boolean);
   procedure UpdateScr(d: TReplyData; addlog: boolean);
   function  GetAllStatus(var d: TReplyData; show: boolean): boolean;
  end;

const
  rcvsize=10000;
  voltage: real = 5.0;
  adc0m: real = 0.0;

type
  rcvbuf = array [0..rcvsize] of char;
  tshowdata=(shhex,shbinary,shascii);

var
  Form1: TForm1;
  nrcv: cardinal;
  rcv: rcvbuf;

implementation

uses Unit2;

{$R *.DFM}


const
  yesno: array[boolean] of string = ('No','Yes');
  onoff: array[boolean] of string = ('Off','On');
  maxCurrent=34.1;
  DivAmp = 30;
  initsection='init';
  gsreply=23;


// tflag
  CurOver1=1;
  CurOver2=2;
  CurOver3=4;
  DoRelay1=8;
  DoRelay2=16;
  DoRelay3=32;
  xxxxxxxx=64;
  Tmeasure=128;

// flag
  UseManual = 1;
  UseAvgc   = 2;
  UseCorrTbl= 4;
  UseMinCurr= 8;
  UseManADC = 16;
  UseManMiMa = 32;

  tflag: array[0..7] of string = ('CurOver1','CurOver2','CurOver3','DoRelay1','DoRelay2','DoRelay3','','TMeasure');
  flag: array[0..7] of string = ('UseManual','UseAvgc','UseCorrTbl','UseMinCurr','UseManADC','','','');
  onoff_porta=8;
  relay_portB6=64;

  cmdlength = 5;
  infocmd = #1;
  resetdevice = #2;
  setrelay = #3;
  get_current = #4;
  getAll = #5;
  setManADC = #6;
  setManual = #7;

  comhandle: thandle= 0;
  readthread: treadthread = nil;
  portopen: boolean = false;
  showsend: boolean = false;
  showdata: tshowdata = shhex;
  showcrlf: boolean = false;
  showlog: boolean = true;
  autoopen: boolean = true;
  loglines: integer = 100;
  timer: integer = 5;
  _AutoSaveData = true;


var
  timervalue: integer;
  inifilepth: string;
  AutoSaveData: boolean = _AutoSaveData;


constructor TReadThread.Create;
begin
 inherited Create(true);
 freeonterminate := true;
 priority := tpNormal;
 resume;
end;

procedure TReadthread.ShowStr;
begin
 if (Form1 <> nil) and (fs <> '') then Form1.addstr('R: '+ fs);
end;

procedure TReadthread.Execute;
var i: integer;
    r: array [0..rcvsize] of char;
    nr,cst:cardinal;
    st: tcomstat;
begin
 fillchar(rcv,sizeof(rcv), 0); nrcv := 0;
 repeat
try
  if ClearCommError(comhandle,cst,@st) then begin
    sleepex(10,true);
    if st.cbInQue > 0 then begin
      if readfile(comhandle, r, sizeof(r)-1, nr, nil) then begin

       if nrcv + nr > rcvsize then begin
        fs := 'Buffer full'; Synchronize(ShowStr);
        nrcv := 0;
        if nr > rcvsize then continue; // discard chars
       end;

        move(r[0],rcv[nrcv],nr); nrcv := nrcv + nr;  fs := '';
        if nr <> 0 then begin
         for i := 0 to nr-1 do begin
          case showdata of
           shhex: begin
            if showcrlf and (r[i] = #13) then fs := fs + '<CR>' else
            if showcrlf and (r[i] = #10) then fs := fs + '<LF>' else
            fs := fs + inttohex(byte(r[i]),2);
           end;
           shbinary: begin
            if showcrlf and (r[i] = #13) then fs := fs + '<CR>' else
            if showcrlf and (r[i] = #10) then fs := fs + '<LF>' else
            fs := fs + binb(byte(r[i]));
           end;
           shascii: begin
            if r[i] = #13 then fs := fs + '<CR>' else
            if r[i] = #10 then fs := fs + '<LF>' else
            if r[i] in [#32..#126] then fs := fs + r[i] else
              fs := fs + '0x'+inttohex(byte(r[i]),2);
           end;
          end;
          if showdata <> shascii then fs := fs + ' ';
         end;
          Synchronize(ShowStr);
        end;
      end;
    end;
  end;
except
 on e: exception do ebox('Thread '+e.message);
end;
 until application.Terminated or terminated;
end;




function waitrcv(chars: byte): boolean;
var t: tdatetime;
    timeout: boolean;
begin
 t := now + 2/(24*3600);
 repeat
  sleepex(100,true);
  timeout := t < now;
  application.ProcessMessages;
 until (nrcv >= chars) or timeout;
 if timeout then result := false else result := true;
end;

function DoOpenPort(var ph: thandle): boolean;
var dcb: tdcb;
    t:COMMTIMEOUTS;
    f: TIniFile;
    c: string;
    brate: integer;
begin
 result := false;
 f := tinifile.create(inifilepth);
try
 c := uppercase(f.ReadString(initsection,'port','\\.\COM1'));
 brate := f.ReadInteger(initsection,'baud',19200);

finally
 f.free;
end;
 ph := CreateFile(pchar(c),
    GENERIC_READ or GENERIC_WRITE, 0,nil, OPEN_EXISTING, 0, 0);

 if ph = INVALID_HANDLE_VALUE then begin
  ebox('CreateFile INVALID_HANDLE_VALUE'#13+syserrormessage(GetLastError));
  exit;
 end;

 dcb.DCBlength := sizeof(dcb);
 if not GetCommState(ph, dcb) then
  begin
   ebox('ComHandle GetCommState '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
   exit;
  end;

 dcb.BaudRate := brate;
 dcb.Parity := 0;
 dcb.ByteSize := 8;
 dcb.StopBits := ONESTOPBIT;

 if not SetCommState(ph, dcb) then
  begin
   ebox('ComHandle SetCommState '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
   exit;
  end;

 EscapeCommFunction(ph, SETDTR);
 EscapeCommFunction(ph, SETRTS);

 if not  getcommtimeouts(ph,t) then
  begin
   ebox('ComHandle GetCommTimeOuts '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
   exit;
  end;

 t.ReadIntervalTimeout := 100;
 t.ReadTotalTimeoutMultiplier := 1;

 if not setcommtimeouts(ph, t) then
  begin
   ebox('ComHandle SetCommTimeOuts '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
   exit;
  end;
{
 if not PurgeComm(ph, PURGE_RXCLEAR or PURGE_TXCLEAR) then begin
  ebox('ComHandle PurgeComm '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
  exit;
 end;
}
 result := true;
end;

procedure ClearCom(h: thandle);
var r: array [0..1000] of char;
    nr,cst:cardinal;
    st: tcomstat;
begin
 if ClearCommError(comhandle,cst,@st) and (st.cbInQue > 0) then begin
  readfile(h, r, sizeof(r)-1, nr, nil);
 end;
end;

function TForm1.OpenPort: boolean;
begin

 if readthread <> nil then
  begin
   readthread.Terminate;
   terminatethread(readthread.handle, 0);
   SetCommMask(comhandle, 0);
   wdelay(500);
  end;

 if comhandle <> 0 then if closehandle(comhandle) then comhandle := 0;
 result := false;

 if not DoOpenPort(comhandle) then exit;

 if not SetCommMask(comhandle, EV_RXCHAR) then begin
  ebox('ComHandle SetCommMask '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
 end;

 sleep(100);
 ClearCom(comhandle);
 readthread := Treadthread.Create;

 result := true;
 portopen := true;
 addstr('COM port opened');
end;


function SendString(s: string): boolean;
var wb: cardinal;
    l: integer;
begin
 result := false;
 fillchar(rcv,sizeof(rcv), 0); nrcv := 0;
 l := length(s);
 if not writefile(comhandle, s[1], l, wb, nil) then begin
  EBox(syserrormessage(getlasterror));
 end else result := true;
end;

procedure TForm1.AddStr(s:string);
begin
 if not showlog then exit;
 m.lines.BeginUpdate;
try
 while m.lines.count > loglines do begin
  m.Lines.Delete(m.lines.count-1);
 end;
 m.lines.insert(0,trimright(s));
finally
 m.lines.EndUpdate;
end;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
 Ibox('3 phase current measure service'#13#13'          (c) Zelenka 2017');
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 close;
end;

const issending: boolean = false;
procedure TForm1.SendCmd(cmd: string; chars: byte);
var s,p: string;
    i: integer;
begin
 if issending then begin
  beep;
  showlog := true;
  addstr('Cmd in progress...');
  exit;
 end;
 issending := true;
try
 sb1.Panels[1].text := '';
 if not portopen then OpenPort;
 for i := length(cmd)+1 to cmdlength do cmd := cmd + #0;
 sb1.Panels[1].text := 'Sending data...';
 p := '';
 for i := 1 to length(cmd) do p := p + '0x'+inttohex(byte(cmd[i]),2)+' ';
 if showsend then addstr('S: '+p)
  else addstr('S: '+inttostr(length(cmd))+'B');
 if sendstring(cmd) then begin
  if waitrcv(chars) then begin
  s := copy(rcv,1,nrcv-2);
  end else begin
   addstr('Receive error!');
   beep;
  end;
 end;
 sb1.Panels[1].Text := p;
finally
 issending := false;
end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 Form2.GraphCanClose(CanClose);
 if not CanClose then Form2.Show;
end;

procedure TForm1.FormCreate(Sender: TObject);
var f: tinifile;
begin
 decimalseparator := '.';
 m.Clear;
 if not fileexists(_exedir+_exename+'.cur') then begin
  XWriteToStringFile('Date       Time      Curr0m Curr0 Curr1 Curr2 Curr3 Relay Lm Mc Mcc Zo'#13#10,_exedir+_exename+'.cur');
 end;

 inifilepth := _exedir+_exename+'.ini';
 f := tinifile.create(inifilepth);
try
 voltage := f.ReadFloat(initsection,'Voltage',voltage);
 AutoSaveData := f.ReadBool(initsection,'AutoSaveData',_AutoSaveData);
 autoopen := f.ReadBool(initsection,'AutoOpen',autoopen);
 loglines := f.ReadInteger(initsection,'LogLines',loglines);
 gridlines := f.ReadInteger(initsection,'GridLines',gridlines);
 timer := f.ReadInteger(initsection,'Timer',timer);
 if timer < 1 then timer := 1;
finally
 f.free;
end;
 cur.Text := '?';
 l1.Text := '?';
 l2.Text := '?';
 l3.Text := '?';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 EscapeCommFunction(comhandle, CLRRTS);
 EscapeCommFunction(comhandle, CLRDTR);
 if comhandle <> 0 then closehandle(comhandle);
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
 OpenPort;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
 if readthread <> nil then
  begin
   readthread.Terminate;
   terminatethread(readthread.handle, 0);
   SetCommMask(comhandle, 0);
   wdelay(500);
  end;
 if comhandle <> 0 then
 if closehandle(comhandle) then begin
  portopen := false;
  comhandle := 0;
 end;
 addstr('COM port closed');
end;

const first:boolean = true;
procedure TForm1.FormActivate(Sender: TObject);
begin
 if first then begin
  first := false;
  if autoopen then OpenPort;
 end;
end;

procedure TForm1.Restart1Click(Sender: TObject);
begin
 if qbox('Are you sure?') = idyes then begin
  SendCmd(resetdevice,2);
  if nrcv >= 2 then begin
  end else ebox('Restart error!');
 end;
end;

procedure TForm1.Info1Click(Sender: TObject);
var b: tshowdata;
begin
 b := showdata;
 showdata := shascii;
 SendCmd(infocmd,16);
 showdata := b;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var d: TReplyData;
    c: word;
begin
 c := round(strtofloat(trim(cur.text)) * DivAmp) and $3FF;
 sendcmd(setManADC+chr(byte(madc.checked))+chr(Hi(c))+chr(Lo(c)),2);
 sendcmd(setManual+chr(byte(mc.checked))+chr(limit.ItemIndex)+chr(byte(ml.checked)),2);
 GetAllStatus(d, false);
end;

procedure TForm1.UpdateScr(d: TReplyData; addlog: boolean);
var xon: boolean;
begin
  cur.Text := format('%d.%d',[d.MCurrent0,d.MCurrent0x]);
  l1.text := inttostr(d.MCurrent1);
  l2.text := inttostr(d.MCurrent2);
  l3.text := inttostr(d.MCurrent3);
  xon := d.pb and relay_portB6 <> 0;
  if xon then relay.Font.Color := clPurple else relay.Font.Color := clGreen;
  relay.caption := 'Relay '+onoff[xon];
  if (d.flags and UseMinCurr) = 0 then
   limit.ItemIndex := 0 else limit.ItemIndex := 1;
   if addlog then begin
    addstr(format('Port A : %s',[binb(d.pa)]));
    addstr(format('Port B : %s',[binb(d.pb)]));
    addstr(format('Port C : %s',[binb(d.pc)]));
    addstr(format('Flags  : %s',[binb(d.flags)]));
    addstr(format('Tflags : %s',[binb(d.tflags)]));
    addstr(format('zofscur: %d',[d.zofscur]));
    addstr(format('ADC0m: %0.4d, Hi: %0.2x, Lo: %0.2x = %6.3f',[d.ADC0m,hi(d.ADC0m),lo(d.ADC0m),d.ADC0m/DivAmp]));
    addstr(format('ADC0 : %0.4d, Hi: %0.2x, Lo: %0.2x = %6.3f',[d.ADC0,hi(d.ADC0),lo(d.ADC0),d.ADC0/DivAmp]));
    addstr(format('ADC1 : %0.4d, Hi: %0.2x, Lo: %0.2x = %6.3f',[d.ADC1,hi(d.ADC1),lo(d.ADC1),d.ADC1/DivAmp]));
    addstr(format('ADC2 : %0.4d, Hi: %0.2x, Lo: %0.2x = %6.3f',[d.ADC2,hi(d.ADC2),lo(d.ADC2),d.ADC2/DivAmp]));
    addstr(format('ADC3 : %0.4d, Hi: %0.2x, Lo: %0.2x = %6.3f',[d.ADC3,hi(d.ADC3),lo(d.ADC3),d.ADC3/DivAmp]));
   end;
   madc.Checked := (d.flags and UseManADC) <> 0;
   mc.Checked := (d.flags and UseManual) <> 0;
   ml.Checked := (d.flags and UseManMiMa) <> 0;
   if ml.Checked then begin
    if (d.flags and UseMinCurr) = 0 then begin // max
     if (d.adc0 <= d.adc1) or (d.adc0 <= d.adc1) or (d.adc0 <= d.adc1) then
      limit.Color := clPurple else limit.Color := clGreen;
    end else begin
     if (d.adc0 >= d.adc1) or (d.adc0 >= d.adc1) or (d.adc0 >= d.adc1) then
      limit.Color := clPurple else limit.Color := clGreen;
    end;
   end else limit.Color := clBtnFace;
end;

function TForm1.GetAllStatus(var d: TReplyData; show: boolean): boolean;
begin
 result := true;
 SendCmd(getAll,gsreply);
 if nrcv = gsreply then begin
  move(rcv,d,sizeof(d));
  move(rcv[11],d.adc0m,10);
  UpdateScr(d, show);
 end else result := false;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
var d: TReplyData;
begin
 if GetAllStatus(d, true) then begin
 end else ebox('GetStatus error!');
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
var xon: boolean;
    d: TReplyData;
begin
 showlog := false;
 SendCmd(getAll,gsreply);
 if nrcv = gsreply then begin
  move(rcv,d,sizeof(d));
  if d.flags and UseManual <> 0 then begin
  xon := d.pb and relay_portB6 <> 0;
  if qbox('Switch relay '+onoff[not xon]+'?') <> id_yes then exit;
   if xon then begin
    SendCmd(setrelay,2);
   end else begin
     SendCmd(setrelay+#1,2);
   end;
   GetAllStatus(d,false);
  end else ebox('Manual control disabled!');
 end else ebox('GetStatus error!');
 showlog := true;
end;

procedure TForm1.GetCurrent(var d: TADCData; errbox: boolean);
begin
 fillchar(d,sizeof(d),0);
 showlog := false;
 SendCmd(Get_Current,12);
 showlog := true;
 if nrcv = 12 then begin
  move(rcv,d,sizeof(d));
  addstr('>');
  addstr(format('ADC0m: %0.4x, Hi: %0.2x, Lo: %0.2x = %6.3f',[d.ADC0m,hi(d.ADC0m),lo(d.ADC0m),d.ADC0m/DivAmp]));
  addstr(format('ADC0 : %0.4x, Hi: %0.2x, Lo: %0.2x = %6.3f',[d.ADC0,hi(d.ADC0),lo(d.ADC0),d.ADC0/DivAmp]));
  addstr(format('ADC1 : %0.4x, Hi: %0.2x, Lo: %0.2x = %6.3f',[d.ADC1,hi(d.ADC1),lo(d.ADC1),d.ADC1/DivAmp]));
  addstr(format('ADC2 : %0.4x, Hi: %0.2x, Lo: %0.2x = %6.3f',[d.ADC2,hi(d.ADC2),lo(d.ADC2),d.ADC2/DivAmp]));
  addstr(format('ADC3 : %0.4x, Hi: %0.2x, Lo: %0.2x = %6.3f',[d.ADC3,hi(d.ADC3),lo(d.ADC3),d.ADC3/DivAmp]));
 end else begin
  if errbox then ebox('GetCurrent error!') else addstr('GetCurrent error!');
 end;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
var d: TADCData;
begin
 GetCurrent(d, true);
end;

const timer_in_progress: boolean = false;
procedure TForm1.Timer1Timer(Sender: TObject);
var d: TReplyData;
begin
 inc(timervalue);
 if timervalue >= timer then begin
  timervalue := 0;
  if timer_in_progress then exit;
  timer_in_progress := true;
try
  showlog := false;
  SendCmd(getAll,gsreply);
  showlog := true;
 if nrcv = gsreply then begin
  move(rcv,d,sizeof(d));
  move(rcv[11],d.adc0m,10);
  UpdateScr(d, false or showlog1.Checked);
 end else begin
   addstr('GetCurrent error!');
 end;
finally
  timer_in_progress := false;
end;
 end;
 sb1.Panels[0].Text := format(' %d',[timer-timervalue]);
end;

procedure TForm1.Enabletimer1Click(Sender: TObject);
begin
 enabletimer1.Checked := not enabletimer1.Checked;
 timervalue := timer;
 timer1.Enabled := enabletimer1.Checked;
 bitbtn1.Enabled := not enabletimer1.Checked;
 bitbtn2.Enabled := not enabletimer1.Checked;
 bitbtn3.Enabled := not enabletimer1.Checked;
 bitbtn4.Enabled := not enabletimer1.Checked;
end;

procedure TForm1.SetCurrentTimerInterval1Click(Sender: TObject);
var s: string;
    v: integer;
    f: tinifile;
begin
 s := inttostr(timer);
 if inputquery('Set current timer interval','Enter new value in seconds',s) then begin
  v := strtoint(s);
  if v < 1 then v := 1;
  if timer <> v then begin
   timer := v;
   addstr('Timer value set to '+inttostr(timer)+'s');
   f := tinifile.create(inifilepth);
try
   f.WriteInteger(initsection,'timer',timer);
finally
   f.free;
end;
  end;
 end;
end;

procedure TForm1.Showlog1Click(Sender: TObject);
begin
 showlog1.Checked := not showlog1.Checked;
end;

procedure TForm1.data1Click(Sender: TObject);
begin
 form2.show;
end;

procedure TForm1.madcClick(Sender: TObject);
begin
 cur.Enabled := madc.Checked;
end;

procedure TForm1.mlClick(Sender: TObject);
begin
 limit.Enabled := ml.Checked;
end;

procedure TForm1.Setmanualcontrol1Click(Sender: TObject);
var d: TReplyData;
begin
 sendcmd(setManual+chr(byte(mc.checked))+chr(limit.ItemIndex)+chr(byte(ml.checked)),2);
 GetAllStatus(d, true);
end;

procedure TForm1.Setmanualcurrentlimit1Click(Sender: TObject);
var d: TReplyData;
    c: word;
begin
 c := round(strtofloat(trim(cur.text)) * DivAmp) and $3FF;
 sendcmd(setManADC+chr(byte(madc.checked))+chr(Hi(c))+chr(Lo(c)),2);
 GetAllStatus(d, false);
end;

end.


