unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Grids, Menus, unitx;

type

  iarray = array [1..2] of real;
  tiarray = array of iarray;
  Tcortbl = array [0..255] of shortint;

  TForm2 = class(TForm)
    sg: TStringGrid;
    img: TImage;
    MainMenu1: TMainMenu;
    Data1: TMenuItem;
    Save1: TMenuItem;
    Load1: TMenuItem;
    Clear1: TMenuItem;
    UpdateGraph1: TMenuItem;
    od: TOpenDialog;
    sd: TSaveDialog;
    N1: TMenuItem;
    CalcCorrectionTable1: TMenuItem;
    Showaxis1: TMenuItem;
    procedure Save1Click(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure sgGetEditMask(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure UpdateGraph1Click(Sender: TObject);
    procedure sgSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure sgDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure CalcCorrectionTable1Click(Sender: TObject);
    procedure Showaxis1Click(Sender: TObject);
    procedure sgSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
   modified: boolean;
   saveload: string;
   procedure UpdatePicture(canvas: TCanvas);
   procedure ShowGraphLine(canvas: TCanvas; x,y,idx: integer);
   procedure CalcArray(var v: tiarray; var c: integer; idx: integer);
   procedure GraphCanClose(var CanClose: boolean);
   procedure GenerateCORRTABLEINCFile(j: byte);
  end;

var
  Form2: TForm2;
  gridlines: integer = 15;
  cortbl: array [1..3] of Tcortbl;

const
  maxdivADC=1023;
  maxinputcurrent=34.1;



implementation

uses Unit1;

{$R *.DFM}

const border=20;
      colors : array [1..7] of TColor=
      (clBlack,clRed,clFuchsia,clOlive,clAqua,clYellow,clLime);



procedure TForm2.GraphCanClose(var CanClose: boolean);
var r: integer;
begin
 if modified then begin
  r := qboxc('Data modified! Save?');
  if r in [idyes,idcancel] then CanClose := false;
 end;
end;
      
procedure TForm2.Save1Click(Sender: TObject);
var i,j: integer;
begin
 sd.FileName := saveload;
 if not sd.Execute then exit;
 saveload := sd.FileName;
 XWriteToNewStringFile('',saveload);
 for i := 1 to sg.RowCount - 1 do
  for j := 2 to sg.ColCount - 1 do
   XWriteToStringFile(sg.Cells[j,i]+#13#10,saveload);
 modified := false;
end;

procedure TForm2.Load1Click(Sender: TObject);
var i,j: integer;
    f: textfile;
    s: string;
begin
 od.FileName := saveload;
 if not od.Execute then exit;
 saveload := od.FileName;
 assignfile(f,saveload);
 reset(f);
 for i := 1 to sg.RowCount - 1 do begin
  for j := 2 to sg.ColCount - 1 do begin
   if not eof(f) then begin
    readln(f,s); sg.Cells[j,i] := s;
   end;
  end;
 end;
 closefile(f);
 modified := false;
 UpdatePicture(img.Picture.Bitmap.Canvas);
end;

procedure TForm2.Clear1Click(Sender: TObject);
var i,j: integer;
begin
 if qbox('Are you sure?') = idyes then begin
  for i := 1 to sg.RowCount - 1 do
   for j := 1 to sg.ColCount - 1 do sg.Cells[j,i] := '';

  sg.Cells[2,1] :=  '0.0';
  sg.Cells[2,sg.RowCount - 1] :=  floattostr(maxinputcurrent);
  sg.Cells[3,sg.RowCount - 1] :=  inttostr(maxdivADC);
  sg.Cells[4,sg.RowCount - 1] :=  inttostr(maxdivADC);
  sg.Cells[5,sg.RowCount - 1] :=  inttostr(maxdivADC);

  UpdatePicture(img.Picture.Bitmap.Canvas);
 end;
end;

procedure TForm2.FormCreate(Sender: TObject);
var i: integer;
begin
 fillchar(cortbl,sizeof(cortbl),0);
 modified := false;
 od.InitialDir := _exedir;
 sd.InitialDir := _exedir;
 saveload := _exedir+_exename+'.sav';
 sg.FixedCols := 2;
 sg.RowCount := gridlines+1;
 sg.ColWidths[0] := 28;
 sg.ColWidths[1] := 63;
 sg.ColWidths[2] := 55;
 sg.Cells[1,0] := ' ADC';
 sg.Cells[2,0] := ' I';
 sg.Cells[3,0] := 'ADC1';
 sg.Cells[4,0] := 'ADC2';
 sg.Cells[5,0] := 'ADC3';
 for i := 1 to sg.RowCount - 1 do
  sg.Cells[0,i] := format('%2d',[i]);

 sg.Cells[2,1] :=  '0.0';
 sg.Cells[2,sg.RowCount - 1] :=  floattostr(maxinputcurrent);
 sg.Cells[3,sg.RowCount - 1] :=  inttostr(maxdivADC);
 sg.Cells[4,sg.RowCount - 1] :=  inttostr(maxdivADC);
 sg.Cells[5,sg.RowCount - 1] :=  inttostr(maxdivADC);
end;

procedure TForm2.FormResize(Sender: TObject);
begin
 img.Picture.Bitmap.width := img.width;
 img.Picture.Bitmap.height := img.height;
 UpdatePicture(img.Picture.Bitmap.Canvas);
end;

procedure SortArray(var v: tiarray; x: integer);
var i,j,c: integer;
    a: real;
begin
 c := length(v);
 for i := 1 to c-1 do
 for j := 1 to c-1 do begin
  if v[j,x] < v[j-1,x] then begin
   a := v[j-1,1]; v[j-1,1] := v[j,1]; v[j,1] := a;
   a := v[j-1,2]; v[j-1,2] := v[j,2]; v[j,2] := a;
  end;
 end;
end;

procedure ShowAxis(x,y,s,cc: integer; canvas: TCanvas);
var c: tcolor;
    p: integer;
begin
 p := Canvas.Pen.Width;
 c := Canvas.Pen.Color;
 Canvas.Pen.Color := cc;
 Canvas.Pen.Width := 1;
 Canvas.MoveTo(x-s,y); Canvas.LineTo(x+s,y);
 Canvas.MoveTo(x,y-s); Canvas.LineTo(x,y+s);
 Canvas.MoveTo(x,y);
 Canvas.Pen.Color := c;
 Canvas.Pen.Width := p;
end;

procedure TForm2.CalcArray(var v: tiarray; var c: integer; idx: integer);
var i,w,j: integer;
    si,sa: string;

begin
 setlength(v,0); c := 0;
 for i := 1 to sg.RowCount - 1 do begin
  si := trim(sg.Cells[2,i]);
  if length(si) > 0 then begin
   j := 1; while j < length(si) do if si[j] = ' ' then
    delete(si,j,1) else inc(j);
  end;
  if (si <> '') and (si <> '.') then begin
   sg.Cells[1,i] :=
    formatfloat('0.0',(strtofloat(si)*maxdivADC/maxinputcurrent));
  end else sg.Cells[1,i] := '';

  repeat w := Pos(' ',si); if w <> 0 then system.delete(si,w,1); until w = 0;
  sa := trim(sg.Cells[idx,i]);
  if (si <> '') and (si <> '.') and (sa <> '') then begin
   inc(c); setlength(v,c);
   v[c-1,1] := strtofloat(si);
   v[c-1,2] := strtoint(sa);
  end;
 end;
end;

procedure TForm2.ShowGraphLine(canvas: TCanvas; x,y,idx: integer);
var i,c,x0,y0,x1,y1,w: integer;
    v: tiarray;
    xa,ya: real;
begin
 if idx > 7 then exit;
 x0 := border; y0 := y - border;
 CalcArray(v,c,idx);

 w :=   Canvas.Pen.Width;
 if c > 0 then begin
  SortArray(v,1);

  xa := (x-2*border)/maxinputcurrent;
  ya := (y-2*border)/maxdivADC;

  Canvas.Pen.Color := colors[idx];
  Canvas.MoveTo(x0,y0);
  Canvas.Pen.Width := 1;
  Canvas.Pen.Style := psDot;
  x1 := round(x0 + v[c-1,1]*xa);
  y1 := round(y0 - v[c-1,2]*ya);
  Canvas.LineTo(x1,y1);

  Canvas.MoveTo(x0,y0);
  Canvas.Pen.Width := w;
  Canvas.Pen.Style := psSolid;
  for i := 0 to c-1 do begin
   x1 := round(x0 + v[i,1]*xa);
   y1 := round(y0 - v[i,2]*ya);
   Canvas.LineTo(x1,y1);
   ShowAxis(x1,y1,7,clBlack,Canvas);
  end;
 end;
 setlength(v,0);
end;

procedure TForm2.UpdatePicture(canvas: TCanvas);
var i,j,x,xx,y,xa,ya: integer;
begin
 x := img.width; y := img.height;
 Canvas.Brush.Color := clWhite;
 Canvas.Pen.Width := 2;
 Canvas.FillRect(rect(0,0,x,y));
 Canvas.Font.Style := [fsBold];
 Canvas.Font.Color := clBlue;
 Canvas.Font.Name := 'Courier New';
 Canvas.Font.Size := 12;
 Canvas.TextOut(4,1,'div|U');
 Canvas.TextOut(x-13,y-border,'I');
 if showaxis1.Checked then begin
  for i := 1 to round(maxinputcurrent) - 1 do begin
   xx := round(i*(x-2*border)/maxinputcurrent);
   showaxis(border+xx,y-border,y-2*border,clGray,Canvas);
  end;
 end;

 Canvas.Pen.Color := clBlack;
 Canvas.MoveTo(border,border);
 Canvas.LineTo(border,y-border);
 Canvas.LineTo(x-border,y-border);

 Canvas.Pen.Width := 1;
 Canvas.Pen.Color := clGreen;
 xa := round(0.5*(x-2*border)/maxinputcurrent);
 ya := round(15*round(y-2*border)/maxdivADC);
 Canvas.TextOut(x-border-xa-Canvas.TextWidth('+0,5A'),1,'+0,5A');
 Canvas.MoveTo(border+xa,y-border);
 Canvas.LineTo(x-border,border+ya);
 Canvas.TextOut(border,y-Canvas.TextHeight('-0,5A'),'-0,5A');
 Canvas.MoveTo(border,y-border-ya);
 Canvas.LineTo(x-border-xa,border);
 Canvas.Pen.Width := 2;

 for j := 3 to sg.ColCount - 1 do begin
  ShowGraphLine(canvas,x,y,j);
 end;
end;

procedure TForm2.sgGetEditMask(Sender: TObject; ACol, ARow: Integer;
  var Value: String);
begin
 if ACol = 2 then Value := '99.99' else Value := '9999';
end;

procedure TForm2.UpdateGraph1Click(Sender: TObject);
begin
 UpdatePicture(img.Picture.Bitmap.Canvas);
end;

procedure TForm2.sgSetEditText(Sender: TObject; ACol, ARow: Integer;
  const Value: String);
begin
 if not sg.EditorMode then begin
  modified := true;
  UpdatePicture(img.Picture.Bitmap.Canvas);
 end;
end;

procedure TForm2.sgDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
 sg.canvas.Font.Assign(sg.font);
 sg.canvas.brush.Color := clBtnFace;
 if (ARow = 0) then begin
  if ACol > 1 then sg.canvas.brush.Color := colors[ACol];
 end else if (ACol > 1) then begin
  sg.canvas.brush.Color := clwhite;
 end;
 if (gdSelected in state) and (gdFocused in state) then begin
  sg.canvas.brush.color := clBlue;
  sg.canvas.Font.color := clWhite;
 end else begin
  sg.canvas.Font.color := clBlack;
 end;
 sg.canvas.FillRect(Rect);
 if (ARow = 0) or (ACol = 0) then begin
  DrawEdge(sg.Canvas.Handle, Rect, BDR_RAISEDINNER, BF_RIGHT + BF_BOTTOM);
  DrawEdge(sg.Canvas.Handle, Rect, BDR_RAISEDINNER, BF_LEFT + BF_TOP);
  inc(Rect.top); inc(Rect.left); dec(Rect.Right); dec(Rect.Bottom);
 end;
 sg.canvas.TextRect(rect,rect.left+2,rect.top+2,sg.cells[acol,arow]);
end;


procedure TForm2.GenerateCORRTABLEINCFile(j: byte);
var i,c: integer;
    fn,he,fo: string;
const fn_='corrtable%d.inc';
      he_='corrtablecompute%d'#13#10+
         '     addwf PCL,F'#13#10+
         'corrtable%d'#13#10;
      fo_=''#13#10+
         ' IF ((HIGH ($-1)) != (HIGH (corrtable%d)))'#13#10+
         '  ERROR "TABLE CROSSES PAGE BOUNDARY!"'#13#10+
         ' ENDIF';
begin
  fn := format(fn_,[j]);
  he := format(he_,[j,j]);
  fo := format(fo_,[j]);
  if fileexists(_exedir+fn) and (qbox('Overwrite file '+_exedir+fn+'?') <> idyes) then exit;//continue;
  XWriteToNewStringFile('',_exedir+fn);
  XWriteToStringFile(he,_exedir+fn);
  for i := 0 to 255 do begin
   if i mod 10 = 0 then
    XWriteToStringFile('; '+inttostr(i)+#13#10,_exedir+fn);
   c := cortbl[j,i];
   if c < 0 then c := abs(c)+128;
   XWriteToStringFile('     retlw .'+inttostr(c)+#13#10,_exedir+fn);
  end;
  XWriteToStringFile(fo,_exedir+fn);
  ibox('File '+_exedir+fn+' created!');
end;

procedure TForm2.CalcCorrectionTable1Click(Sender: TObject);
var zo,i,j,l,c,adc,found,lfound,k,r,ei: integer;
    s,s0: string;
    v: tiarray;
    ic,lic,kf,ladc: real;
    err: boolean;
begin
 fillchar(cortbl,sizeof(cortbl),0);

 err := false; ei := 0;
 k := round(maxdivADC/maxinputcurrent);
 s := inttostr(round(k));

 zo := 0; s := inttostr(zo);

 for l := 1 to 3 do begin
  CalcArray(v,c,2+l);
  if c > 1 then begin
   SortArray(v,1);

   if v[0,1] = 0 then begin
    s := ''; s0 := '';
    lfound := 0; kf := 0; lic := 0;
    ladc := v[0,2];

    for i := 0 to 34 do begin
     ic := i;
     adc := round(k*ic);

     for j := 1 to c - 1 do begin
      if v[j,1] >= ic then begin
       found := j;
       if (found <> lfound) then begin
         kf := (v[found,2] - v[lfound,2])/(v[found,1] - v[lfound,1]);
         lfound := found;
         ladc := v[j,2];
         lic := v[j,1];
       end;
       break;
      end;
     end;

     r := round(adc - ladc - kf*(ic-lic)  + zo);
     if abs(r) > 127 then begin
      if r < 0  then r := -127 else r := 127;
      if i < (maxinputcurrent) then begin
       inc(ei); err := true;
      end;
     end;
     cortbl[l,i] := shortint(r);
     s := s + format('%3d ',[cortbl[l,i]]);
     s0 := s0 + format('%3d ',[i]);
    end;
    if err then ebox(format('Correction exceeded max value 127! (%dx)',[ei]));
    xwritetonewstringfile(s0+#13#10,_exedir+_exename+inttostr(l)+'.inc');
    xwritetostringfile(s,_exedir+_exename+inttostr(l)+'.inc');
    GenerateCORRTABLEINCFile(l);
   end else EBox('Missing ADC'+inttostr(l)+' value for 0 A!');
  end else IBox('Nothing to do for ADC'+inttostr(l));
  setlength(v,0);
 end;
end;


procedure TForm2.Showaxis1Click(Sender: TObject);
begin
 showaxis1.Checked := not showaxis1.Checked;
 UpdateGraph1Click(Sender);
end;

procedure TForm2.sgSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
var i: integer;
    s,p: string;
    x: real;
begin
 if ACol >= 3 then begin
   s := trim(sg.Cells[ACol, ARow]);
   if s <> '' then begin
    p := trim(sg.Cells[2, ARow]);
    repeat
     i := Pos(' ',p);  if i <> 0 then system.Delete(p,i,1); i := Pos(' ',p);
    until i = 0;
    x := (strtoint(s) * maxinputcurrent / maxdivADC) - strtofloat(p);
    img.Picture.Bitmap.Canvas.TextOut(border + 10,30,'Diff: '+format('%.2f',[x])+'A    ');
   end;
 end;
end;

end.
